<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Python Features</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>
		<div class="reveal">
			<div class="slides">
				<section>
				    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h1>Python Features</h1>
					</section>
					<section>
						<h2>Python Features Overview</h2>
						<ul>
                            
							<li><b>The Language</b></li>
							<li><b>Python Usage</b></li>
                            <li><b>PyDocs</b></li>
                            <li><b>Standard Library</b></li>
                            <li><b>Styling and PEP8</b></li>
                            <li><b>Objects</b></li>
							<li><b>2.x and 3.x differences</b></li>
							<li><b>Python Interpetor</b></li>
							<li><b>Running Python</b></li>
						</ul>
                    </section>
                    <section>
                        <h2>Objectives</h2>
                        <a href="../objectives.html" target="_blank">Python Features Objectives</a>
                    </section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Introduction to Python</h2>
						<img src="../../assets/guido.jpg" alt="guido">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
                            <li>Python is a high level programming language used for generic-purpose programming</li>
                            <li>Python was created by Gudio van Rossum and released in 1991</li>
                            <li>It's dynamic type system, auto memory management and standard library</li>
                            <li>Open Source</li>
                        </ul>
					</section>
				</section>
                <section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h3>Why Python?</h3>
                        <ul>
                            <li><b>High Level: </b> strong abstraction of details from computer</li>
                            <li><b>Interpreted: </b> directly executes instructions and provides immediate feedback</li>
                            <li><b>Readable: </b> very easy to read, learn and understand</li>
                            <li><b>Cross-Platform: </b> runs almost anywhere</li>
                        </ul>
                    </section>
                    <section>
                        <h3>Why Python (Cont.)</h3>
                        <ul>
                            <li><b>Batteries-Included: </b> deep functionality built into standard library</li>
                            <li><b>General Language: </b> can be used to do just about anything.</li>
                            <li><b>Object Oriented Programming: </b> allows code to be reused, encapsulated, maintained easier and organized cleaner.</li>
                        </ul>
                    </section>
                </section>
                <section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h3>Python Usage</h3>
                        <ul>
                            <li>Prototyping</li>
                            <li>Cross-platform scripts</li>
                            <li>Automation and testing</li>
                            <li>Vulnerability Research/Fuzzing</li>
                            <li>Create/replicate pieces of software you do not otherwise have access to</li>
                        </ul>
                    </section>
                    <section>
                        <h3>Python Usage</h3>
                        <ul>
                            <li>Web Development</li>
                            <li>GUI/UX</li>
                            <li>Gaming</li>
                            <li>Etc.</li>
                        </ul>
                    </section>
                </section>

				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>PyDoc(s)</h2>
						<ul>
							<li><b>Python Documentation</b> and is the go-to resource for everything Python.</li>
                            <li><b>PyDoc</b> is a command that evokes the Python interpreter and utilizes the <b>help()</b> function</li>
                            <li>You can also open up the Python interpreter and use help(object) replacing object with the object you want to look up.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<li>
								<b>help()</b> is a function that gives you a TON of data. For instance, object methods, module, important information, help, etc.
							</li>
							<li>Understanding how to use PyDocs, pydoc command and help() function is not only testable... but it's an essential piece in becoming proficient in Python.</li>
						</ul>
						<p><a href="https://docs.python.org/2.7/">2.7 Docs</a></p>
						<p><a href="https://docs.python.org/3/">3.x Docs</a></p>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Standard Library</h2>
                        <ul>
                            <li>The <b>Python Standard Library</b> contains all of the built in functionality of Python</li>
                            <li><a href="https://docs.python.org/2.7/library/index.html">2.7 libraries</a></li>
                            <li><a href="https://docs.python.org/3.7/library/index.html">3.x libraries</a></li>
                        </ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Styling and PEP8</h2>
                        <ul>
                            <li><b>Python Enhancement Protocol 8</b></li>
							<li>
                                Python is <b>whitespace sensitive!</b> 
                                <ul>
                                    <li>Python does not use brackets</li>
                                    <li>Python utilizes an indentation system.</li>
                                </ul> 
							</li>
							<li>
                                <b>Spaces</b> are preferred over tabs, you cannot mix. 
                                <ul>
                                    <li><b>PEP8</b> commands 4 spaces per indention level (tab)</li>
                                </ul>
							</li>
						</ul>
						<p><a href="https://www.python.org/dev/peps/pep-0008/">PEP8</a></p>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Documenting Code</h2>
						<p>Python brings many features we are already familiar with in other programming languages, but gives the user a bit more power in their documentation.</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
							<code data-trim data-noescape>
								# This is a comment
							</code>
						</pre>
						<pre>
							<code data-trim data-noescape>
								"""This is a single line docstring"""
							</code>
						</pre>
						<pre>
							<code data-trim data-noescape>
								"""This is a multiline 
								comment"""

							</code>
						</pre>
						<pre>
							<code data-trim data-noescape>
								"""This is a multiline docstring

								Notice the separation? Let's get into that and explain it. 
								"""
							</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>What is the difference between Docstrings and Comments?</h3>
						<p>Docstrings are used to provide a convenient way to associate modules, functions, classes and methods with Python documentation.</p>
                        <ul>
							<li>Docstrings are best used to describe what a section of code does.</li>
							<li>Comments focus on the how and implementation of the code.</li>
						</ul>
						<pre>
							<code data-trim data-noescape>
								"""This function takes a list of strings and returns a deduplicated copy."""

								# convert the list to a set then back to a list to dedup.
							</code>
						</pre>
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h2>Exercise</h2>
					<ul>
						<li style="font-size: 24px;">Take a moment to step through PEP8 and and learn the styling and formatting requirments</li>
						<li style="font-size: 24px;">Pay most attention to the basics:
							<ul>
								<li style="font-size: 24px;">Indentation</li>
								<li style="font-size: 24px;">Maximum line length</li>
								<li style="font-size: 24px;">The entire comments section
									<ul>
										<li style="font-size: 24px;">Ensure to include a docstring at the top of all of your labs that includes your:
											<ul>
												<li style="font-size: 24px;">name</li>
												<li style="font-size: 24px;">project/lab</li>
												<li style="font-size: 24px;">date</li>
											</ul>
										</li>
									</ul>
								</li>
								<li style="font-size: 24px;">Naming Conventions</li>
								<li style="font-size: 24px;">Remember what else in contained within and return to PEP8 as we learn new concepts. You are expected to abide by PEP8 during the class.</li>
							</ul>
						</li>
					</ul>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Objects in Python</h2>
                        <ul>
                            <li>Everything in Python is an Object
                                <ul>
                                    <li>An object is just a struct</li>
                                    <li>An encapsulation of variables and functions into a single entity</li>
                                    <li><b>Inheritance</b> simply means an object can be assigned to a variable or passed into a function for example</li>
                                </ul>
                            </li>
                        </ul>
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h2>Objects Lab</h2> 
					<a href="../lab1a.html">Lab 1A</a>
				</section>

				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Py2 vs Py3 Differences</h2>
						<p>
							Python 2 and 3 are similar but <b>NOT COMPATIBLE!</b> Python 3 does break compatibility. We will be focusing on Python 3.7 but will cover 2.7 along side the entire course. Here are just a few of the major differences:
						</p>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%"> 
						<h2>Print</h2>
						<p>Python 3 replaced Python 2's print statement with a print function(). While Python 2 will be happy as is or with parentheses... Python 3 will throw an error if the parentheses are not included.</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Python 2 Print</h2>
						<pre>
							<code data-trim data-noescape>
								print 'Hello World!' # outputs: Hello World!
								mystr = 'Goodbye World!' # Notice we didn't declare a type?
	
								print mystr # outputs: Goodbye World!
								print("This works too") # This works too!
							</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Python 3 Print</h2>
						<pre>
							<code data-trim data-noescape>
								print("Hello World!") # Hello World!
								mystr = 'Goodbye World!' # Again, no type declared. It's automatically determined. 
	
								print(mystr) # Goodbye World!
							</code>
						</pre>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Integer Division</h2>
						<ul>
							<li>Python 2 treats numbers without a decimal as integers</li>
                            <li>Python 3 will treat them as float if it applies</li>
                            <li>Python 2 Division with integers <b>truncates</b> the remainder! Setting one number as a real number will yield the correct result</li>
                        </ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Python 2</h2>
						<pre>
							<code data-trim data-noescape>
								print 3/2 # 1
								print 3.0/2 # 1.5
							</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Python 3</h2>
						<pre>
							<code data-trim data-noescape>
								print (3/2) # 1.5
							</code>
						</pre>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Other Major Differences</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Unicode</h2>
                        <ul>
                            <li>Python 2 has ASCII str() type, separate unicode() type.. but no byte() type</li>
                            <li>Python 3 has Unicode (utf-8) str-ings and two byte classes: byte and bytearray</li>
                        </ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>input() vs raw_input()</h2>
						<ul>
							<li>Python 3 <b>input()</b> always stores userinput as str objects</li>
							<li>
                                Python 2 input() on the other hand fully evaluates the code the user gives it 
                                <ul>
                                    <li>This is dangerous, and can be used in a malicious way</li>
                                    <li>Instead, we use <b>raw_input()</b> in Python 2... which converts user input to a string.</li>
                                </ul>
							</li>
						</ul>
					</section>
				</section>

				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h2>Running Python</h2>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Python Interpreter</h2>
						<p>
							The Python Interpreter uses a concept called <b>REPL</b>:
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<li><b>Read</b> the user input
								<ul>
									<li>Some constructs like loops might be multiple lines</li>
								</ul>
							</li>
							<li><b>Evaluate</b> the input
								<ul>
									<li>Attempt to perform the instruction</li>
								</ul>
							</li>
							<li><b>Print</b>: to the screen and
								<ul>
									<li>Print any requested info or an error with stack trace</li>
								</ul>
							</li>
							<li><b>Loop:</b>
								<ul>
									<li>Print the next user prompt or loop until evalution complete</li>
								</ul>
							</li>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Launching Python</h2>
						<p>The Python Interpreter can be launched from the command prompt or terminal using the following commands:</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Linux and OS X</h2>
						<ul>
							<li><b>python2 or python</b> generally opens up Python 2</li>
							<li><b>python3</b> generally opens up Python 3 (will open an out dated Python 3 one some distros)</li>
							<li><b>python3.7</b> opens up Python 3.7 currently on Fedora</li>
							<li>This is all dependent on a number of factors</li>
							<li>You can create aliases if you wish</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Windows</h2>
						<ul>
							<li><b>py -2</b> generally opens up Python 2</li>
							<li><b>py -3 or py</b> generally opens up Python 3</li>
							<li>Again, this is all dependent on a number of factors</li>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Additional Commands/Info</h2>
						<ul>
							<li><b>exit() or shorcut ctrl-D</b> to exit the Python Interpreter</li>
							<li>Typing simply a variable or expression will yield a printed output</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
							<code data-trim data-noescape>
								# >>> represents the interpreter asking for a command. 

								>>> x = 100
								>>> x
								100
								>>> x + 5
								105
								>>> x
								100
							</code>
						</pre>
						<p>Conditionals can be checked and loops can be executed. Be sure to provide indentation. This can be done via pressing the space bar 2 or 4 times per line or pressing tab.</p>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Python Source Files</h2>
						<p>
							The other way to run Python code is using source files with the extension of .py. Python does not require compilation on the user's end. Executing .py source code is similar to starting the Interpreter.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Be sure to:</p>
						<ul>
							<li>Use appropiate bash commands for the source code's Python version</li>
							<li>Include filename and extension after bash command</li>
							<li>Include any arguments after filename and extension.</li>
							<li>We will go over ways to execute multiple files later in the course.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Executing files</h2>
						<pre>
							<code data-trim data-noescape>
								$ ls
								file.txt    fileIO.py    hello_world.py    hello_world_3.py

								$ python hello_world.py
								Hello World!

								$ python3 hello_world_3.py
								Hello World for Python 3!
							</code>
						</pre>
					</section>
				</section>
				<section>
				    <h2>Questions?</h2>
				</section>
				<section>
				    <h2>Summary</h2>
				    <ul>
						<li><b>The Language</b></li>
						<li><b>Python Usage</b></li>
                        <li><b>PyDocs</b></li>
                        <li><b>Standard Library</b></li>
                        <li><b>Styling and PEP8</b></li>
                        <li><b>Objects</b></li>
						<li><b>2.x and 3.x differences</b></li>
						<li><b>Python Interpetor</b></li>
						<li><b>Running Python</b></li>
					</ul>
				</section>
			</div>
		</div>
		<footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

					// If slides do not have a matching title, attempt to use the
					// start of the text content as the title instead
					useTextContentForMissingTitles: false,

					// Hide slides from the menu that do not have a title.
					// Set to 'true' to only list slides with titles.
					hideMissingTitles: false,

					// Adds markers to the slide titles to indicate the 
					// progress through the presentation. Set to 'false'
					// to hide the markers.
					markers: true,

					// Specify custom panels to be included in the menu, by
					// providing an array of objects with 'title', 'icon'
					// properties, and either a 'src' or 'content' property.
					custom: false,

					// Specifies the themes that will be available in the themes
					// menu panel. Set to 'true' to show the themes menu panel
					// with the default themes list. Alternatively, provide an
					// array to specify the themes to make available in the
					// themes menu panel, for example...
					// [
					//     { name: 'Black', theme: 'css/theme/black.css' },
					//     { name: 'White', theme: 'css/theme/white.css' },
					//     { name: 'League', theme: 'css/theme/league.css' }
					// ]
					themes: true,

					// Specifies the path to the default theme files. If your
					// presentation uses a different path to the standard reveal
					// layout then you need to provide this option, but only
					// when 'themes' is set to 'true'. If you provide your own 
					// list of themes or 'themes' is set to 'false' the 
					// 'themesPath' option is ignored.
					themesPath: 'css/theme/',

					// Specifies if the transitions menu panel will be shown.
					// Set to 'true' to show the transitions menu panel with
					// the default transitions list. Alternatively, provide an
					// array to specify the transitions to make available in
					// the transitions panel, for example...
					// ['None', 'Fade', 'Slide']
					transitions: true,

					// Adds a menu button to the slides to open the menu panel.
					// Set to 'false' to hide the button.
					openButton: true,

					// If 'true' allows the slide number in the presentation to
					// open the menu panel. The reveal.js slideNumber option must 
					// be displayed for this to take effect
					openSlideNumber: true,

					// If true allows the user to open and navigate the menu using
					// the keyboard. Standard keyboard interaction with reveal
					// will be disabled while the menu is open.
					keyboard: true,

					// Normally the menu will close on user actions such as
					// selecting a menu item, or clicking the presentation area.
					// If 'true', the sticky option will leave the menu open
					// until it is explicitly closed, that is, using the close
					// button or pressing the ESC or m key (when the keyboard 
					// interaction option is enabled).
					sticky: true,

					// If 'true' standard menu items will be automatically opened
					// when navigating using the keyboard. Note: this only takes 
					// effect when both the 'keyboard' and 'sticky' options are enabled.
					autoOpen: true,

					// If 'true' the menu will not be created until it is explicitly
					// requested by calling RevealMenu.init(). Note this will delay
					// the creation of all menu panels, including custom panels, and
					// the menu button.
					delayInit: false,

					// If 'true' the menu will be shown when the menu is initialised.
					openOnInit: false,

					// By default the menu will load it's own font-awesome library
					// icons. If your presentation needs to load a different
					// font-awesome library the 'loadIcons' option can be set to false
					// and the menu will not attempt to load the font-awesome library.
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
		</script>
	</body>
</html>
